You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

359 lines
17 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`$GPG --full-gen-key\` first.\\n"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync\` must be installed to run mutt-wizard.\\n" && exit
  10. case "$(uname)" in
  11. Linux) prefix="/usr" ;;
  12. *) prefix="/usr/local" ;;
  13. esac
  14. muttdir="$HOME/.config/mutt" # Main mutt config location
  15. accdir="$muttdir/accounts" # Directory for account settings
  16. maildir="$HOME/.local/share/mail" # Location of mail storage
  17. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  18. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  19. muttshare="$prefix/share/mutt-wizard"
  20. mbsyncrc="$HOME/.mbsyncrc"
  21. mwconfig="$muttshare/mutt-wizard.muttrc"
  22. cachedir="$HOME/.cache/mutt-wizard"
  23. muttrc="$muttdir/muttrc"
  24. msmtprc="$HOME/.config/msmtp/config"
  25. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  26. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  27. do
  28. [ -f "$x" ] && sslcert="$x" && break
  29. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  30. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  31. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  32. getprofiles() { \
  33. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  34. printf "Creating profiles for \`%s\`..." "$title"
  35. msmtp_header="defaults
  36. auth on
  37. tls on
  38. tls_trust_file $sslcert
  39. logfile ~/.config/msmtp/msmtp.log
  40. "
  41. msmtp_profile="account $title
  42. host $smtp
  43. port $sport
  44. from $fulladdr
  45. user $login
  46. passwordeval \"pass mutt-wizard-$title\"
  47. $starttlsoff
  48. "
  49. mbsync_profile="IMAPStore $title-remote
  50. Host $imap
  51. Port $iport
  52. User $login
  53. PassCmd \"pass mutt-wizard-$title\"
  54. SSLType $ssltype
  55. CertificateFile $sslcert
  56. MaildirStore $title-local
  57. Subfolders Verbatim
  58. Path ~/.local/share/mail/$title/
  59. Inbox ~/.local/share/mail/$title/INBOX
  60. Flatten .
  61. Channel $title
  62. Expunge Both
  63. Master :$title-remote:
  64. Slave :$title-local:
  65. Patterns * !\"[Gmail]/All Mail\"
  66. Create Both
  67. SyncState *
  68. MaxMessages $maxmes
  69. # End profile
  70. "
  71. if [ "$accounttype" = "offline" ]; then
  72. mutt_profile="# vim: filetype=neomuttrc
  73. # muttrc file for account $title
  74. set realname = \"$realname\"
  75. set from = \"$fulladdr\"
  76. set sendmail = \"msmtp -a $title\"
  77. alias me $realname <$fulladdr>
  78. set folder = \"$maildir/$title\"
  79. set header_cache = $cachedir/$title/headers
  80. set message_cachedir = $cachedir/$title/bodies
  81. set mbox_type = Maildir
  82. bind index,pager gg noop
  83. bind index,pager g noop
  84. bind index,pager M noop
  85. bind index,pager C noop
  86. bind index gg first-entry
  87. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  88. unmailboxes *
  89. "
  90. else
  91. mutt_profile="# vim: filetype=neomuttrc
  92. # muttrc file for account $title
  93. set realname = \"$realname\"
  94. set from = \"$fulladdr\"
  95. set sendmail = \"$prefix/bin/msmtp -a $title\"
  96. alias me $realname <$fulladdr>
  97. set folder = \"imaps://$fulladdr@$imap:$iport\"
  98. set imap_user = \"$login\"
  99. set header_cache = $cachedir/$title/headers
  100. set message_cachedir = $cachedir/$title/bodies
  101. set imap_pass = \"\`pass mutt-wizard-$title\`\"
  102. set mbox_type = Maildir
  103. set ssl_starttls = yes
  104. set ssl_force_tls = yes
  105. bind index,pager gg noop
  106. bind index,pager g noop
  107. bind index,pager M noop
  108. bind index,pager C noop
  109. bind index gg first-entry
  110. unmailboxes *
  111. "
  112. fi
  113. printf "DONE.\\n"
  114. }
  115. askinfo() { \
  116. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  117. read -r fulladdr
  118. printf "\033[0m"
  119. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  120. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  121. read -r fulladdr
  122. printf "\033[0m"
  123. done
  124. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  125. search_query=$domain
  126. case "$domain" in
  127. protonmail.com|protonmail.ch|pm.me)
  128. search_query='protonmail.com' && break;;
  129. *)
  130. while : ; do
  131. printf "\nIs your email hosted with Protonmail? [yes/no] "
  132. read -r is_protonmail
  133. case $is_protonmail in
  134. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  135. [Nn][Oo]) break;;
  136. *) printf 'Please answer Yes or No'
  137. esac; done;
  138. esac
  139. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  140. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  141. if [ -z "$serverinfo" ]; then
  142. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  143. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  144. read -r imap
  145. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  146. read -r iport
  147. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  148. read -r smtp
  149. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  150. read -r sport
  151. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  152. else
  153. IFS=, read -r service imap iport smtp sport <<EOF
  154. $serverinfo
  155. EOF
  156. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  157. case "$service" in
  158. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  159. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  160. esac
  161. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  162. fi
  163. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  164. read -r realname
  165. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  166. read -r title
  167. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  168. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  169. read -r title
  170. printf "\033[0m"
  171. done
  172. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  173. read -r login
  174. printf "\033[0m"
  175. [ -z "$login" ] && login="$fulladdr"
  176. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  177. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  178. getpass
  179. getprofiles
  180. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  181. getaccounts
  182. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  183. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  184. echo "$msmtp_profile" >> "$msmtprc"
  185. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  186. case "$service" in
  187. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  188. esac
  189. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  190. echo "$mbsync_profile" >> "$mbsyncrc"
  191. notmuchauto
  192. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  193. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  194. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  195. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  196. }
  197. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  198. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  199. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  200. }
  201. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  202. pass insert "mutt-wizard-$title" && break; done ;}
  203. formatShortcut() { \
  204. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  205. echo "macro index,pager M$1 \"<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  206. echo "macro index,pager C$1 \"<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  207. done ;}
  208. tryconnect() { mkdir -p "$maildir/$title"
  209. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  210. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  211. printf "\033[32mMailboxes detected.\033[0m\\n"
  212. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  213. return 0
  214. else
  215. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  216. return 1
  217. fi ;}
  218. finalize() { \
  219. boxes="$(find "$maildir/$title/" -mindepth 1 -maxdepth 1 | sed "s/\ /\\\ /g;s/^.*\//=/")"
  220. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  221. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  222. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  223. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  224. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  225. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  226. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  227. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  228. echo "mailboxes =$title ===================== $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  229. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  230. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  231. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  232. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  233. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  234. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  235. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  236. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  237. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  238. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  239. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  240. return 0
  241. }
  242. confirm() { printf "Do you want to %s? [y/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  243. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  244. return 0 ;}
  245. pick() { printf "Select an accounts to %s:\\n" "$1"
  246. list
  247. read -r input
  248. [ -z "$input" ] && return 1
  249. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  250. [ -z "$title" ] && printf "Invalid response." && return 1
  251. return 0 ;}
  252. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  253. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  254. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  255. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  256. }
  257. choosecron() { ! pgrep cron >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  258. if crontab -l | grep mailsync >/dev/null; then
  259. echo "Active mail sync cronjob detected. Do you want to remove it?"
  260. printf "\033[36m\t"
  261. read -r rmyn
  262. printf "\033[0m"
  263. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  264. else
  265. echo "How many minutes between each mail sync?"
  266. printf "\033[36m\t"
  267. read -r minnum
  268. printf "\033[0m"
  269. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  270. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  271. read -r minnum
  272. printf "\033[0m"
  273. done
  274. (crontab -l; echo "*/$minnum * * * * export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/$(id -u)/bus; export DISPLAY=:0; . \$HOME/.profile; $(type mailsync | cut -d' ' -f3)") | crontab - &&
  275. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  276. fi ;}
  277. asktype() { while : ; do
  278. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  279. read -r offnot
  280. case "$offnot" in
  281. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  282. [Nn][Oo]) accounttype="online" && break ;;
  283. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  284. esac; done ;}
  285. purge() { confirm "delete all account data" || exit
  286. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  287. crontab -l | sed '/mailsync/d' | crontab - >/dev/null
  288. echo "All configs and account settings have been purged."
  289. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  290. }
  291. notmuchauto() { \
  292. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  293. [ -f "$NOTMUCH_CONFIG" ] && return 0
  294. nmbasic="[database]
  295. path=$maildir
  296. [user]
  297. name=$realname
  298. primary_email=$fulladdr
  299. [new]
  300. tags=unread;inbox;
  301. ignore=
  302. [search]
  303. exclude_tags=deleted;spam;
  304. [maildir]
  305. synchronize_flags=true
  306. [crypto]
  307. gpg_path=$GPG"
  308. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  309. trap 'echo -e "\033[0m\n"; exit' STOP INT ABRT KILL
  310. case "$1" in
  311. ls) list ;;
  312. add) asktype && askinfo && tryconnect && finalize || delete ;;
  313. pass) pick "change the password of" && getpass ;;
  314. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  315. purge) purge ;;
  316. cron) choosecron ;;
  317. *) cat << EOF
  318. mw: mutt-wizard, auto-configure email accounts for mutt
  319. including downloadable mail with \`isync\`.
  320. Allowed options:
  321. add Add and autoconfigure an email address (9 max.)
  322. ls List configured accounts
  323. delete Pick an account to delete
  324. purge Delete all accounts and settings
  325. cron Enable or disable an autosync via cronjob
  326. all else Print this message
  327. NOTE: Once at least one account is added, you can run
  328. \`mbsync -a\` to begin downloading mail.
  329. EOF
  330. esac